/*--------------------------------------------------------------------------*/
/* mainwindow.cpp                                                           */
/*                                                                          */
/* 2019-05-22 First version                                             HS  */
/*--------------------------------------------------------------------------*/

#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "qdatetime.h"

//----------------------------------------------------------------------------
// MainWindow ctor
MainWindow::MainWindow(QWidget* parent) : QMainWindow(parent), ui(new Ui::MainWindow)
{
// window preamble chores
    ui->setupUi(this);

    logText("Welcome to the RegisterHotKeyDemo");
    logText("Try typing] ctrl-E in any program");

// register a hotkey with Windows
    if (!::RegisterHotKey(reinterpret_cast<HWND>(winId()),100,MOD_CONTROL,'E'))
        logText("RegisterHotKey() failed");
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::logText(QString sText)
{
    ui->listWidget->addItem(QDateTime::currentDateTime().toString() + ": " + sText);
    ui->listWidget->scrollToBottom();
}

void MainWindow::on_pushButton_clicked()
{
    qApp->exit();
}

bool MainWindow::nativeEvent(const QByteArray& eventType, void* message, long* result)
{
    Q_UNUSED(eventType)
    Q_UNUSED(result)

// transform the message pointer to the MSG WinAPI
    MSG* msg = reinterpret_cast<MSG*>(message);

// is it our hotkey?
    if ((WM_HOTKEY == msg->message) && (100 == msg->wParam))
    {
        logText("Got the hotkey");
        return true;
    }

// else say we didn't process the message
    return false;
}
